Index: tmp/org.txm.core/src/java/org/txm/importer/AddAttributeValuesInXML.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/AddAttributeValuesInXML.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/AddAttributeValuesInXML.groovy	(revision 881)
@@ -0,0 +1,99 @@
+package org.txm.importer
+
+import java.io.File;
+import java.util.ArrayList;
+import java.util.List;
+
+import org.txm.metadatas.Entry
+import org.txm.utils.Pair;
+
+/**
+ * Add a attribute value map in a XML file
+ * Warning: if an attribute already exists its value won't be changed
+ */
+class AddAttributeValuesInXML extends StaxIdentityParser {
+	File xmlFile;
+	String tag, attribute;
+	List<String> values;
+	HashMap<String, String> attributesMap;
+	boolean result;
+
+	public AddAttributeValuesInXML(File xmlFile, String tag, String attribute, List<String> values)
+	{
+		super(xmlFile.toURI().toURL());
+		this.xmlFile = xmlFile;
+		this.tag = tag;
+		this.attribute = attribute;
+		this.values = values;
+	}
+
+	public boolean process(File outfile) {
+		this.result = false;
+		boolean ret = super.process(outfile)
+		return this.result & ret;
+	}
+
+	/**
+	 * Rewrite the processStartElement() to update/add attributes
+	 */
+	int n = 0;
+	public void processStartElement()
+	{
+		if (localname != tag) {
+			super.processStartElement()
+		} else {
+			String prefix = parser.getPrefix();
+			if (INCLUDE == localname && XI == prefix) {
+				processingXInclude();
+				return;
+			}
+
+			if (prefix.length() > 0)
+				writer.writeStartElement(Nscontext.getNamespaceURI(prefix), localname)
+			else
+				writer.writeStartElement(localname);
+
+			for (int i = 0 ; i < parser.getNamespaceCount() ; i++) {
+				writer.writeNamespace(parser.getNamespacePrefix(i), parser.getNamespaceURI(i));
+			}
+
+			// get attributes
+			HashMap<String, String> attributes = new HashMap<String, String>();
+			for (int i = 0 ; i < parser.getAttributeCount() ; i++) {
+				attributes[parser.getAttributeLocalName(i)] = parser.getAttributeValue(i);
+			}
+			// add/update the value
+			if (n < values.size()) {
+				attributes[attribute] = values[n]; 
+			} else {
+				println "ERROR: not enough values to insert for file $xmlFile, at XML parser location: l="+parser.getLocation().getLineNumber()+",c="+parser.getLocation().getColumnNumber()+")."
+			}
+			n++
+			
+			// write attributes
+			for (def k : attributes.keySet()) {
+				writer.writeAttribute(k, attributes[k])
+			}
+		}
+	}
+	
+	@Override
+	public void after() {
+		super.after();
+		
+		if (n != values.size()) {
+			println "ERROR: number of $tag ("+n+") missmatch the number of values to insert: "+values.size()
+		}
+	}
+
+	public static void main(String[] args)
+	{
+		File xmlfile = new File("/home/mdecorde/xml/macroaddfacsattribute/src/test1.xml")
+		File temp = File.createTempFile("temp", ".xml", xmlfile.getParentFile());
+
+		AddAttributeValuesInXML builder = new AddAttributeValuesInXML(xmlfile, "pb", "facs", ["V1","V1.2", "V2", "V3"]);
+		builder.process(temp);
+		
+		println "Done"
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/GetPagesFromURL.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/GetPagesFromURL.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/GetPagesFromURL.groovy	(revision 881)
@@ -0,0 +1,74 @@
+package org.txm.importer
+
+import org.w3c.tidy.Tidy
+
+def workDir = new File("/home/mdecorde/TEMP")
+def outdir = new File("/home/mdecorde/TEMP/out")
+
+def src = "http://txm.sourceforge.net/doc/manual/manual1.xhtml";
+def base = src.substring(0, src.lastIndexOf("/"));
+
+def url_xpath = """//*/a[@href]/@href""";
+def url_regexp = /.+/;
+def duplicates = false; // 'true' not implemented
+def filename_regexp = /zer/;
+def content_xpath = "//*/div[@id=\"content\"]";
+
+def xhtmlFile = new File(workDir, "src.xhtml")
+URL2XHTMLFILE(src, xhtmlFile, workDir);
+
+println "finding urls of $xhtmlFile"
+XPathResult xpathResult = new XPathResult(xhtmlFile);
+def urls = new LinkedHashSet<String>();
+
+for (String url : xpathResult.getXpathResponses(url_xpath))
+	if (urls ==~ url_regexp ) urls << url
+println urls
+
+int i = 1;
+for (String url : urls) {
+	//url = url.replaceAll()
+	def subxHtmlFile = new File(workDir, url)
+	URL2XHTMLFILE(base+"/"+url, subxHtmlFile, workDir);
+	
+	def txtFile = new File(outdir, url+".xhtml")
+	def writer = txtFile.newWriter("UTF-8");
+	for (def node : xpathResult.getNodes(content_xpath)) {
+		writer.println(node)
+	}
+	writer.close()
+	i++
+}
+
+def URL2XHTMLFILE(String url, File outfile, File workDir) {
+	println "getting src: $url"
+	def htmlFile = new File(workDir, "base.html")
+	def filestream = new FileOutputStream(htmlFile)
+	def out = new BufferedOutputStream(filestream)
+	out << new URL(url).openStream()
+	out.close()
+	
+	println "xHTMLize HTML $htmlFile"
+	Tidy tidy = new Tidy(); // obtain a new Tidy instance
+	tidy.setXHTML(true); // set desired config options using tidy setters
+	tidy.setInputEncoding("UTF-8")
+	tidy.setOutputEncoding("UTF-8")
+	tidy.setShowErrors(0)
+	tidy.setTabsize(10)
+	tidy.setShowWarnings(false)
+	File xhtmlFile = new File(workDir, "base.xhtml")
+	xhtmlFile.withWriter("UTF-8") { out2 ->
+		tidy.parse(htmlFile.toURI().toURL().newInputStream([readTimeout: 10000]), out2); // run tidy, providing an input and output stream
+	}
+	
+	println "remove entities and doctype"
+	String text = xhtmlFile.getText("UTF-8")
+	text = text.replaceAll("&nbsp;", " ")
+	text = text.replaceAll("xmlns=\"http://www.w3.org/1999/xhtml\"", " ")
+	text = text.replaceAll("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
+"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">""", "")
+	outfile.withWriter("UTF-8") { writer ->
+		writer.write(text);
+	}
+}
+println "done"
\ No newline at end of file
Index: tmp/org.txm.core/src/java/org/txm/importer/Doc2Transcription.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/Doc2Transcription.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/Doc2Transcription.groovy	(revision 881)
@@ -0,0 +1,122 @@
+package org.txm.importer
+
+import javax.xml.stream.*
+import java.net.URL
+
+class Doc2Transcription {
+
+	String encoding
+	File txtfile
+	File outfile
+	Reader reader
+	XMLOutputFactory factory
+	FileOutputStream output
+	XMLStreamWriter writer
+
+	int noline = 1
+	boolean question = false
+	int idquestion = 1
+	int idresponse = 1
+	boolean opened = false
+
+	public Doc2Transcription(File txtfile, File outfile, String encoding)
+	{
+		this.txtfile = txtfile
+		this.outfile = outfile
+		this.encoding = encoding
+
+		reader = new InputStreamReader(new FileInputStream(txtfile) , encoding)
+		factory = XMLOutputFactory.newInstance()
+		output = new FileOutputStream(outfile)
+		writer = factory.createXMLStreamWriter(output, "UTF-8")//create a new file
+	}
+
+	public boolean process()
+	{
+		if(reader == null || writer == null)
+		{
+			println "I/O error"
+			return false
+		}
+		
+		// build text id
+		String filename = txtfile.getName()
+		int idx = filename.lastIndexOf(".")
+		if(idx > 0)
+			filename = filename.substring(0, idx)
+
+		//write Start doc
+		writer.writeStartDocument("UTF-8", "1.0")
+		writer.writeStartElement("text") // we create a tag <text>
+		writer.writeAttribute("id",filename)// and set its id
+
+		//write first block
+		writeStartQuestionResponse()
+		
+		String line = reader.readLine()
+		while(line != null)
+		{
+			if(line.length() == 0) // saut de ligne
+			{
+				question = !question
+				writer.writeEmptyElement("br")
+				writeStartQuestionResponse()
+			}
+			else
+			{
+				writer.writeCharacters(line+" \n")
+				writer.writeEmptyElement("br")
+			}
+
+			noline++
+			line = reader.readLine()
+		}
+
+		//close xml doc and question/response if needed
+		if(opened)
+			writer.writeEndElement()// question/response
+		writer.writeEndElement()// text
+
+		reader.close()
+		writer.close()
+		output.close()
+		return true
+	}
+
+	public void writeStartQuestionResponse()
+	{
+		if(opened)
+		{
+			writer.writeEndElement()
+			opened = false
+		}
+		opened = true
+		if(question)
+		{
+			writer.writeStartElement("question") // we create a tag <text>
+			writer.writeAttribute("id","q"+idquestion++)// and set its id
+		}
+		else
+		{
+			writer.writeStartElement("response") // we create a tag <text>
+			writer.writeAttribute("id","r"+idresponse++)// and set its id
+		}
+	}
+
+	public void setInitialeState(boolean state)
+	{
+		question = state
+	}
+
+	static main(args) {
+		File infile = new File("/home/matt/xml/txttranscription/test.txt")
+		File outfile = new File("/home/matt/xml/txttranscription/test.xml")
+		String encoding = "UTF-8"
+
+		def builder = new Doc2Transcription(infile, outfile, encoding)
+		if(builder.process())
+			println "ok"
+		else
+			println "fail"
+	}
+}
\ No newline at end of file
Index: tmp/org.txm.core/src/java/org/txm/importer/WriteIdAndNAttributes.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/WriteIdAndNAttributes.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/WriteIdAndNAttributes.groovy	(revision 881)
@@ -0,0 +1,231 @@
+package org.txm.importer
+
+class WriteIdAndNAttributes extends StaxIdentityParser {
+
+	String textname
+
+	int nMileStone = 1, nPb = 1, nCb = 1, nLb = 1, nW = 1, nSeg = 1, nRejet = 1;
+	String previousMileStone, previousPb, previousCb, previousW;
+
+
+	String PB = "pb", CB = "cb", LB = "lb", ID = "id", TYPE = "type",
+	N = "n", CORRESP = "corresp", FACS="facs", W="w", PC="pc", SEG="seg",
+	UNIT="unit", XML="xml", WP="wp", SURFACE="surface", POINT = ".", REJET ="rejet";
+
+	public WriteIdAndNAttributes(File xmlFile, String textname) {
+		super(xmlFile);
+
+		this.textname = textname
+	}
+
+	protected void writeAttributes() {
+		// do nothing
+	}
+
+	protected void processStartElement() {
+		String id = null
+		String n = null
+		String type = null
+		String corresp = null
+		String facs = null
+
+		for (int i = 0 ; i < parser.getAttributeCount() ; i++) {
+			if (parser.getAttributeLocalName(i) == ID) {
+				id = parser.getAttributeValue(i)
+			} else if (parser.getAttributeLocalName(i) == N) {
+				n = parser.getAttributeValue(i)
+			} else if (parser.getAttributeLocalName(i) == TYPE) {
+				type = parser.getAttributeValue(i)
+			} else if (parser.getAttributeLocalName(i) == CORRESP) {
+				corresp = parser.getAttributeValue(i)
+			} else if (parser.getAttributeLocalName(i) == FACS) {
+				facs = parser.getAttributeValue(i)
+			}
+		}
+
+		super.processStartElement(); // attributes are not written because super.writeAttributes() is not called
+
+		if (localname == "milestone" && parser.getAttributeValue(null, UNIT) == SURFACE) {
+			if (n == null) {
+				n = nMileStone
+			} else {
+				int tmp = Integer.parseInt(n)
+				if (nMileStone < tmp) {
+					nMileStone = tmp
+					n = tmp
+				} else {
+					n = nMileStone;
+				}
+			}
+
+			if (id == null) { // don't rewrite "id"
+				if (facs == null) {
+					println "Error: found milestone@type=\"surface\" with no @facs at "+parser.getLocation()
+					throw new Exception("no facs attribute")
+				}
+				if (facs.lastIndexOf(POINT) > 0) facs = facs.substring(0, facs.lastIndexOf(POINT))
+				previousMileStone = "surf_$textname"+"_"+facs
+				id = previousMileStone
+			} else {
+				previousMileStone = id
+			}
+
+			nMileStone++
+		} else if (localname == PB) {
+			if (n == null) {
+				n = nPb
+			} else {
+				try {
+					int tmp = Integer.parseInt(n)
+					if (nPb < tmp) {
+						nPb = tmp
+					} else {
+						n = nPb;
+					}
+				} catch(Exception e) { }
+			}
+
+			if (id == null) { // don't rewrite "id"
+				id = "page_${textname}_"+nPb
+				previousPb = "${textname}_"+nPb
+			} else {
+				previousPb = id
+			}
+
+			nRejet = nLb = nCb = 1
+			nPb++
+		} else if (localname == CB) {
+			if (n == null) {
+				n = nCb
+			} else {
+				try {
+					int tmp = Integer.parseInt(n)
+					if (nCb < tmp) {
+						nCb = tmp
+					} else {
+						n = nCb;
+					}
+				} catch(Exception e) { }
+			}
+
+			if (id == null) { // don't rewrite "id"
+				previousCb = "${previousPb}_"+nCb
+				id = "col_${previousPb}_"+nCb
+			} else {
+				previousCb = id
+			}
+
+			nLb = nRejet = 1
+			nCb++
+		} else if (localname == LB) {
+			if (n == null) {
+				if (REJET == type) {
+					println "Warning: no 'n' attribute provided for 'rejet' line break at "+parser.getLocation()
+				}
+				
+				n = nLb
+			} else {
+				if (REJET != type) {
+					try { // if n is numeric update nLgRelative
+						int tmp = Integer.parseInt(n)
+						nLb = tmp;
+					} catch(Exception e) {
+						// n is not numeric use it
+					}
+				}
+			}
+
+			if (id == null) { // don't rewrite "id"
+				if (REJET == type) {
+					id = "line_${previousCb}_"+n+"_r"+nRejet
+				} else {
+					id = "line_${previousCb}_"+n
+				}
+			}
+
+			if (corresp == null && REJET == type) {
+				//println "Warning: no 'corresp' attribute provided for 'rejet' line break at "+parser.getLocation()
+				corresp = "#line_${previousCb}_"+n; // next word id in the same column
+			}
+
+			if (REJET != type) {
+				nLb++;
+			} else {
+				nRejet++;
+			}
+
+		} else if (localname == W || localname == PC) {
+			if (n == null) {
+				n = nW
+			} else {
+				try {
+					int tmp = Integer.parseInt(n)
+					if (nW < tmp) {
+						nW = tmp
+					} else {
+						n = nW;
+					}
+				} catch(Exception e) { }
+			}
+
+			if (id == null) { // don't rewrite "id"
+				//previousW = "${previousPb}_"+nW
+				id = localname+"_${textname}_"+nW
+			} 
+			previousW = id
+			nSeg = 1
+			nW++
+		} else if (localname == SEG && WP == type) {
+			if (n == null) {
+				n = nSeg
+			} else {
+				try {
+					int tmp = Integer.parseInt(n)
+					if (nSeg < tmp) {
+						nSeg = tmp
+					} else {
+						n = nSeg;
+					}
+				} catch(Exception e) { }
+			}
+
+			if (id == null) { // don't rewrite "id"
+				id = "w_p_"+previousW+"_"+nSeg
+			}
+			nSeg++
+		}
+
+		// write attributes except ID, N and CORRESP
+		for (int i = 0 ; i < parser.getAttributeCount() ; i++) {
+			if (parser.getAttributeLocalName(i) == ID) {
+
+			} else if (parser.getAttributeLocalName(i) == N) {
+
+			}  else if (parser.getAttributeLocalName(i) == CORRESP) {
+
+			} else {
+				writeAttribute(parser.getAttributePrefix(i), parser.getAttributeLocalName(i), parser.getAttributeValue(i))
+			}
+		}
+		//if (localname == "lb") println "write id: "+["xml", "id", id]
+		if (id != null)
+			writeAttribute(XML, ID, id)
+		if (n != null)
+			writeAttribute(null, N, n)
+		if (corresp != null)
+			writeAttribute(null, CORRESP, corresp)
+	}
+
+	public static void main(String[] args) {
+		File xmlFile = new File("/home/mdecorde/xml/bugrejet/Psautier5-or28.xml")
+		File outFile = new File("/home/mdecorde/xml/bugrejet/Psautier5-or28-o.xml")
+
+		WriteIdAndNAttributes wiana = new WriteIdAndNAttributes(xmlFile, "qgraal_cm")
+		println wiana.process(outFile)
+
+		String text = xmlFile.getText().replaceAll(">", ">\n");
+		new File("/home/mdecorde/xml/bugrejet/Psautier5-or28-p.xml").write(text);
+		text = outFile.getText().replaceAll(">", ">\n");
+		new File("/home/mdecorde/xml/bugrejet/Psautier5-or28-o-p.xml").write(text);
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/WriteIdAndNAttributesUltraGeneric.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/WriteIdAndNAttributesUltraGeneric.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/WriteIdAndNAttributesUltraGeneric.groovy	(revision 881)
@@ -0,0 +1,141 @@
+package org.txm.importer
+
+class WriteIdAndNAttributesUltraGeneric extends StaxIdentityParser {
+
+	String baseID = ""
+	def rules = [];
+
+	def idCounters = [:]
+	def nCounters = [:]
+	def parentIds = [:]
+	
+	def elements;
+	def elementShortNames
+	def elementParents
+	def elementResets
+	def elementSelection
+	public WriteIdAndNAttributesUltraGeneric(File xmlFile, def elements, def elementSelection, def elementShortNames, def elementParents, def elementResets) {
+		super(xmlFile)
+		
+		this.elements = elements;
+		this.elementSelection = elementSelection
+		this.elementShortNames = elementShortNames;
+		this.elementParents = elementParents
+		this.elementResets = elementResets
+		
+		this.baseID = xmlFile.getName();
+		if (baseID.indexOf(".") > 0) baseID = baseID.substring(0, baseID.indexOf("."))
+		
+		for (String element : elements) {
+			idCounters[element] = 1;
+			nCounters[element] = 1;
+			parentIds[element] = null;
+		}
+	}
+
+	/**
+	 * Special rule to add @corresp=#ref to its reference element to element which @attribute=@value
+	 */
+	public setReferenceRule(String element, String attribute, String value) {
+		this.rules << [element, attribute, value]
+	}
+	
+	protected void writeAttributes() {
+		if (!idCounters.containsKey(localname) ) {
+			super.writeAttributes();
+			return;
+		} 
+		println "write attributes $localname"
+		boolean idFound = false
+		boolean nFound = false
+		
+		
+		for (int i = 0 ; i < parser.getAttributeCount() ; i++) {
+			String name = parser.getAttributeLocalName(i);
+			String value = parser.getAttributeValue(i);
+			
+			println " at $name=$value"
+			
+			//String element_sign = [localname, name, value]
+			
+			if ("id" == name) {
+				if (value == null) {
+					value = getNextID()
+				} 
+				
+				parentIds[localname] = value
+			} else if ("n" == name) {
+				if (value == null) {
+					value = getNextN()
+				} else {
+					nCounters[localname] = Integer.parseInt(value)
+				}
+			}
+			
+			String attrPrefix = parser.getAttributePrefix(i);
+			if (attrPrefix != null && attrPrefix.length() > 0)
+				writer.writeAttribute(attrPrefix+":"+name, value);
+			else
+				writer.writeAttribute(name, value);
+		}
+		
+		if (!idFound) {
+			String value = getNextID()
+			writer.writeAttribute("id", value);
+			parentIds[localname] = value
+		}
+		if (!nFound) {
+			String value = getNextN()
+			writer.writeAttribute("n", value);
+		}
+		
+		
+		idCounters[localname]++
+	}
+	
+	protected void processStartElement() {
+		
+		if (idCounters.containsKey(localname)) {
+			println "Element: "+localname
+			for (String resetElement : elementResets[localname]) {
+				println "reset N: "+resetElement
+				nCounters[resetElement] = 1
+			}
+		}
+		
+		super.processStartElement();
+	}
+	
+	protected String getNextID() {
+		String value = elementShortNames[localname]
+		
+		String parent = elementParents[localname]
+		if (parent != null)
+			value += "_"+parentIds[parent]
+		else
+			value += "_"+baseID
+			
+		value += "-"+idCounters[localname]
+		
+		return value
+	}
+	
+	protected String getNextN() {
+		String value = Integer.toString(nCounters[localname])
+		nCounters[localname]++
+		return value
+	}
+	
+	public static void main(String[] args) {
+		File xmlFile = new File("/home/mdecorde/TEMP/idnmissing.xml")
+		File outFile = new File("/home/mdecorde/TEMP/idnmissing-fix.xml")
+		
+		WriteIdAndNAttributesUltraGeneric wiana = new WriteIdAndNAttributesUltraGeneric(xmlFile, 
+			["milestone", "pb", "cb", "lb"],
+			["milestone":"unit=surface", "pb":null, "cb":null, "lb":null],
+			["milestone":"surf", "pb":"page", "cb":"col", "lb":"line"], 
+			["milestone":null, "pb":null, "cb":"pb", "lb":"cb"],
+			["milestone":[], "pb":["cb", "lb"], "cb":[ "lb"], "lb":[]])
+		println wiana.process(outFile)
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/HasElement.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/HasElement.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/HasElement.groovy	(revision 881)
@@ -0,0 +1,67 @@
+package org.txm.importer
+
+import javax.xml.stream.*;
+import java.net.URL;
+
+/**
+ * Check if a file contains a tag
+ * @author mdecorde
+ *
+ */
+class HasElement {
+
+	HashSet<String> localnames = new HashSet<String>();
+	File xmlfile;
+	XMLStreamReader parser;
+	HashMap<String, Boolean> elements = [:];
+
+	public HasElement(File xmlfile, String localname) {
+		localnames << localname;
+		this.xmlfile = xmlfile;
+		elements[localname] = false;
+
+		init();
+	}
+
+	private void init() {
+		try {
+			
+//			println "xmlfile: "+xmlfile
+//			println "xmlfile exists: "+xmlfile.exists()
+//			println "uri: "+ xmlfile.toURI()
+//			println "url: "+ xmlfile.toURI().toURL()
+//			
+			def inputData = xmlfile.toURI().toURL().openStream();
+			def inputFactory = XMLInputFactory.newInstance();
+			parser = inputFactory.createXMLStreamReader(inputData);
+		} catch (Exception ex) {
+			System.out.println("IOException while parsing: "+ex);
+			ex.printStackTrace();
+		}
+	}
+
+	public boolean process() {
+		if (parser == null) return false;
+		
+		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+			if (event == XMLStreamConstants.START_ELEMENT) {
+				String localname = parser.getLocalName();
+				if (localnames.contains(localname)) {
+					parser.close();
+					return true;
+				}
+			}
+		}
+		parser.close();
+	}
+	
+	public static void main(String[] args) {
+		File dir = new File("/home/mdecorde/xml/lamoplat")
+		println dir.listFiles()
+		for (File xmlfile : dir.listFiles()) {
+			if (!xmlfile.getName().endsWith(".xml")) continue
+			//println xmlfile
+			println "$xmlfile: "+ new HasElement(xmlfile, "text").process();
+		}
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/SplitBy.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/SplitBy.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/SplitBy.groovy	(revision 881)
@@ -0,0 +1,204 @@
+package org.txm.importer
+
+import java.io.Writer;
+import java.io.File;
+import javax.xml.stream.*;
+import java.net.URL;
+import org.txm.importer.filters.*;
+
+class SplitBy 
+{
+	
+	XMLOutputFactory factory = XMLOutputFactory.newInstance();
+	FileOutputStream output;
+	XMLStreamWriter writer;
+	def parser;
+	ArrayList<String> newfiles = [];
+	
+	public SplitBy(File xmlfile)
+	{
+		try {
+			def inputData = xmlfile.toURI().toURL().openStream();
+			def inputFactory = XMLInputFactory.newInstance();
+			parser = inputFactory.createXMLStreamReader(inputData);
+			
+		} catch (XMLStreamException ex) {
+			System.out.println(ex);
+		}catch (IOException ex) {
+			System.out.println("IOException while parsing ");
+		}
+	}
+	boolean inby = false;
+	public boolean process(File outdir, String by, String idAttribute)
+	{
+		outdir.mkdirs();
+		try
+		{
+			for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
+				
+				switch(event)
+				{
+					case XMLStreamConstants.START_ELEMENT:
+						if(parser.getLocalName() == by)
+						{
+							
+							inby = true;
+							if(writer != null)
+							{
+								writer.close();
+								output.close();
+							}
+							
+							String filename = "";
+							for(int i = 0 ; i < parser.getAttributeCount(); i++)
+								if(parser.getAttributeLocalName(i) == idAttribute)
+								{
+									filename = parser.getAttributeValue(i);
+									break;
+								}
+							File newfile = new File(outdir,filename+".xml")
+							if(files.contains(newfile))
+							{
+								println "Item declared twice "+filename+" at location "+parser.getLocation();
+								return false;
+							}
+							files.add(newfile);
+							output = new FileOutputStream(newfile)
+							writer = factory.createXMLStreamWriter(output, "UTF-8");//create a new file
+							
+						}
+						if(writer != null)
+						{
+							writeEvent(event);
+							if(parser.getLocalName() == "TEI")
+							{ // write namespaces
+								writer.writeNamespace("tei", "http://www.tei-c.org/ns/1.0")
+								writer.writeNamespace("txm", "http://textometrie.org/1.0")
+							}
+						}
+						break;
+					case XMLStreamConstants.END_ELEMENT:
+						if(inby)
+						{
+							if(writer != null)
+							{
+								writer.writeEndElement();
+							}
+						}
+						if(parser.getLocalName() == by)
+						{
+							inby = false; // write the end element $by before
+						}
+						break;
+					case XMLStreamConstants.CHARACTERS:
+						if(writer != null)
+						{
+							writer.writeCharacters(parser.getText());
+						}
+						break;
+				}
+				
+			}
+			if(writer != null)
+				writer.close();
+			if(output != null)
+				output.close();
+			return true;
+		}
+		catch(Exception e){
+			println "XML Error at location: "+parser.getLocation()
+			e.printStackTrace()
+			if(writer != null)
+				writer.close()
+				output.close()
+				return false
+			}
+	}
+	
+	/**
+	 * write the current event.
+	 *
+	 * @param event the stax event
+	 */
+	private void writeEvent(int event)
+	{
+		def prefix = parser.getPrefix();
+		if (event == XMLStreamConstants.START_ELEMENT ) 
+		{
+			def localname = parser.getLocalName(); // write element
+			if (prefix != null && prefix.length() > 0)
+				writer.writeStartElement(prefix+":"+localname);
+			else
+				writer.writeStartElement(localname);
+			
+			for(int i = 0 ; i < parser.getNamespaceCount() ; i++) //write namespaces
+			{
+				writer.writeNamespace(parser.getNamespacePrefix(i), parser.getNamespaceURI(i));
+			}
+			
+			String attrprefix; // write attributes
+			for (int i = 0 ; i < parser.getAttributeCount() ; i++)
+			{
+				attrprefix = parser.getAttributePrefix(i);
+				if (attrprefix != null & attrprefix.length() > 0)
+					writer.writeAttribute(attrprefix+":"+parser.getAttributeLocalName(i), parser.getAttributeValue(i))
+				else
+					writer.writeAttribute(parser.getAttributeLocalName(i), parser.getAttributeValue(i))
+			}
+			//writer.writeCharacters("\n");
+		}
+		else if (event == XMLStreamConstants.END_ELEMENT)
+		{
+			writer.writeEndElement();
+			//writer.writeCharacters("\n");
+		}
+		else if (event == XMLStreamConstants.CHARACTERS)
+		{
+			writer.writeCharacters(parser.getText());
+		}
+		else if (event == XMLStreamConstants.COMMENT)
+		{
+			writer.writeComment(parser.getText());
+		}
+	}
+	
+	public ArrayList<File> getFiles()
+	{
+		return newfiles;
+	}
+	
+	public static void main(String[] args)
+	{
+		File xmlfile = new File("C:\\Documents and Settings\\mdecorde\\Bureau\\MISAT2011\\corpus\\tiempo\\ELTIEMPO.2002-2010.MIN.xml");
+		File okfile = new File("C:\\Documents and Settings\\mdecorde\\Bureau\\MISAT2011\\corpus\\tiempo\\");
+		File outdir = new File("C:\\Documents and Settings\\mdecorde\\Bureau\\MISAT2011\\corpus\\tiempo\\tiempo");
+		outdir.deleteDir();
+		outdir.mkdir();
+		
+		//		Reader reader = new InputStreamReader(new FileInputStream(xmlfile) , "ISO-8859-1");
+		//		Writer writer = new OutputStreamWriter(new FileOutputStream(okfile) , "UTF-8");
+		//		String line = reader.readLine();
+		//		while(line != null)
+		//		{
+		//			line = line.replaceAll(' ([a-zA-Z0-9]+)="(.*)""', ' $1="$2"')
+		//			writer.write(line+"\n");
+		//			line = reader.readLine();
+		//		}
+		//		reader.close();
+		//		writer.close();
+		//		
+		//		
+		////		if(!ValidateXml.test(okfile))
+		////		{
+		////			println "XML not valid";
+		////			return;
+		////		}
+		
+		def splitter = new SplitBy(xmlfile);
+		if(splitter.process(outdir, "texte", "id"))
+			println "success";
+		else
+			println "failed !"
+		
+	}
+}
Index: tmp/org.txm.core/src/java/org/txm/importer/RemoveTag.groovy
===================================================================
--- tmp/org.txm.core/src/java/org/txm/importer/RemoveTag.groovy	(revision 0)
+++ tmp/org.txm.core/src/java/org/txm/importer/RemoveTag.groovy	(revision 881)
@@ -0,0 +1,120 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.importer;
+
+import javax.xml.parsers.*
+import javax.xml.transform.*
+import javax.xml.transform.dom.DOMSource
+import javax.xml.transform.stream.StreamResult
+import javax.xml.xpath.*
+
+import org.txm.metadatas.*
+import org.txm.utils.*
+import org.w3c.dom.Document
+import org.w3c.dom.Element
+
+/**
+ * Removes tags of XML file given a XPath. 
+ * @author mdecorde
+ *
+ */
+public class RemoveTag {
+	File outfile;
+	
+	/** The doc. */
+	Document doc;
+	
+	/**
+	 *
+	 * @param xmlfile the xmlfile
+	 * @param outfile the outfile
+	 * @param xpath the XPath
+	 */
+	public RemoveTag(File xmlfile, File outfile, String xpath)
+	{
+		this.outfile = outfile;
+		DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
+		domFactory.setNamespaceAware(true); // never forget this!
+		domFactory.setXIncludeAware(true);
+		DocumentBuilder builder = domFactory.newDocumentBuilder();
+		doc = builder.parse(xmlfile);
+		
+		def expr = XPathFactory.newInstance().newXPath().compile(xpath);
+		def nodes = expr.evaluate(doc, XPathConstants.NODESET);
+		
+		if (nodes != null)
+		for(def node : nodes)
+		{
+			//println "Remove node "+node
+			Element elem = (Element)node;
+			elem.getParentNode().removeChild(node);
+		}
+		save()
+		doc = null
+	}
+	
+	/**
+	 * Save.
+	 *
+	 * @return true, if successful
+	 */
+	private boolean save()
+	{
+		try {
+			// Création de la source DOM
+			Source source = new DOMSource(doc);
+			
+			// Création du fichier de sortie
+				Writer writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfile), "UTF-8")); 
+			Result resultat = new StreamResult(writer);
+			
+			// Configuration du transformer
+			TransformerFactory fabrique = new net.sf.saxon.TransformerFactoryImpl();
+			Transformer transformer = fabrique.newTransformer();
+			transformer.setOutputProperty(OutputKeys.METHOD, "xml");
+			transformer.setOutputProperty(OutputKeys.INDENT, "yes"); 
+			transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8"); 
+			
+			// Transformation
+			transformer.transform(source, resultat);
+			writer.close();
+			return true;
+		} catch (Exception e) {
+			org.txm.utils.logger.Log.printStackTrace(e);
+			return false;
+		}
+	}
+	
+	public static void main(String[] args) {
+		RemoveTag rt = new RemoveTag(
+			new File("/home/mdecorde/TXM/corpora/graal/import.xml"),
+			new File("/home/mdecorde/TXM/corpora/graal/import-o.xml"),
+			"//edition[@name='courante']"
+			)
+	}
+}
